package jemu.ui;

import jemu.ui.Switches;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;
import java.net.URL; 

/**
 * Title:        JEMU
 * Description:  The Java Emulation Platform
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */

public class Display extends JComponent {
  final URL floppyicon = getClass().getResource("image/disc.gif");
  final Image floppy = getToolkit().getImage(floppyicon);
  final URL floppyicon2 = getClass().getResource("image/discbig.gif");
  final Image floppy2 = getToolkit().getImage(floppyicon2);
  final URL aboutim = getClass().getResource("image/onlogo.png");
  final Image about = getToolkit().getImage(aboutim);

  private static final long serialVersionUID = 1L;
  public static final int CENTER            = 0;
  public static int loadgames               = 0;
  public static int bootgames               = 0;
  public static int autotype               = 0;
  public static int loadtimer               = 0;
  public static int showboot                = 0;
  protected boolean scanlines;
  public static String monmessage           = "Colour monitor"; // Message which monitor (CPC)
  public static String automessage          = "Autosave is OFF"; // Message which monitor (CPC)
  public static int showmon                 = 250;
  public static int showauto                = 250;
  public static int showpause               = 0;
  public static int showfps                 = 0;
  public static int showmodel               = 0;
  protected int timer = 0;
  public static String model;
  public static final Color LED             = new Color(0xff, 0x00, 0x00);
  public static final Color GREEN           = new Color(0x00, 0xff, 0x00);
  public static final Color LED_BORDER      = new Color(0x90, 0x00, 0x00);
  public static final Color LED_OFF         = new Color(0x90, 0x00, 0x00);
  public static final Color WHITEA          = new Color(0xff, 0xff, 0xff);
  public static final Color BLACKA          = new Color(0x00, 0x00, 0x00);
  public static final Color REDA            = new Color(0xff, 0x00, 0x00);
  public static final Color YELLOWA         = new Color(0xff, 0xFF, 0x00);
  public static final Color ALERT           = new Color(0xff, 0x00, 0x00);
  public static final Color BLUEA           = new Color(0x50, 0x90, 0xff);
  public static int txtpos                  = 300;
  public static int txtstart                = 300;
  public static int ledOn                   = 0;
  public static int showdisk                = 0;
  public static final Dimension SCALE_1     = new Dimension(1,1);
  public static final Dimension SCALE_2     = new Dimension(2,2);
  public static final Dimension SCALE_1x2   = new Dimension(1,2);

  protected BufferedImage image;
  protected WritableRaster raster;
  protected int[] pixels;
  protected int imageWidth, imageHeight;
  protected int scaleWidth, scaleHeight, scaleW, scaleH;
  public static Rectangle imageRect = new Rectangle();
  public static Rectangle sourceRect = null;             // Source rectangle in image
  public static int ztext                   = 0 - 20;
  public static int ytext                   = ztext;
  protected int imagePos = CENTER;
  protected boolean sameSize;
  protected boolean painted = false;
  

  public Display() {
      int[] pixelsc = new int[16 * 16];
Image imagec = Toolkit.getDefaultToolkit().createImage(
        new MemoryImageSource(16, 16, pixelsc, 0, 16));
Cursor blankCursor =
        Toolkit.getDefaultToolkit().createCustomCursor
             (imagec, new Point(0, 0), "invisibleCursor");
setCursor(blankCursor);
    enableEvents(AWTEvent.FOCUS_EVENT_MASK);
    setFocusTraversalKeysEnabled(true);
    setRequestFocusEnabled(true);
  }

  public void setImageSize(Dimension size, Dimension scale) {
    imageWidth = size.width;
    imageHeight = size.height;
    image = new BufferedImage(imageWidth,imageHeight,BufferedImage.TYPE_INT_RGB);
    //image.setAccelerationPriority(1);
    raster = image.getRaster();
    pixels = new int[imageWidth * imageHeight];
    for (int i = 0; i < pixels.length; i++)
      pixels[i] = 0xff000000;
    if (scale == null) scale = SCALE_1;
    scaleWidth = imageWidth * scale.width;
    scaleHeight = imageHeight * scale.height;
    scaleW = scaleWidth;
    scaleH = scaleHeight;
    checkSize();
    Graphics g = getGraphics();
   /* if (g != null) {
      size = getSize();
      g.setColor(getBackground());
      g.fillRect(0,0,size.width,size.height);
      paint(g);
      g.dispose();
    }*/
  }

  public void setBounds(int x, int y, int width, int height) {
      super.setBounds(x,y,width,height);
    checkSize();
  }

  protected void checkDouble(){
    if (Switches.doublesize == true){
        scaleWidth= scaleW * 2;
        scaleHeight= scaleH * 2;
    }
    if (Switches.triplesize == true){
        scaleWidth= scaleW * 3;
        scaleHeight= scaleH * 3;
    }
    if (Switches.triplesize == false){
    if (Switches.doublesize == false){
        scaleWidth = scaleW;
        scaleHeight = scaleH;
    }}
    

  }
  
  protected void checkSize() {
    checkDouble();
    Dimension size = getSize();
    Insets insets = getInsets();
    int clientWidth = size.width - insets.left - insets.right;
    int clientHeight = size.height - insets.top - insets.bottom;
    if (true)
   if (Switches.stretch == 0)
      imageRect = new Rectangle(insets.left + (clientWidth - scaleWidth) / 2,
        insets.top + (clientHeight - scaleHeight) / 2,scaleWidth,scaleHeight);
    else
    {

      imageRect = new Rectangle(insets.left,insets.top,clientWidth,clientHeight);
    sameSize = imageRect.width == imageWidth && imageRect.height == imageHeight;
    }
    
    }
  
  public int[] getPixels() {
    return pixels;
  }
  
  public void setSourceRect(Rectangle value) {
    sourceRect = value;
  }

  public void updateImage(boolean wait) {
    painted = false;
    if (imageRect.width != 0 && imageRect.height != 0 && isShowing()) {
      raster.setDataElements(0,0,imageWidth,imageHeight,pixels);
      repaint(0,imageRect.x,imageRect.y,imageRect.width,imageRect.height);
      if (wait)
        waitPainted();
    }
  }

  protected void paintImage(Graphics g) {
	  if (showfps >=1)
	  doTouchFPS();
	      {if (sourceRect != null)
	      g.drawImage(image,imageRect.x,imageRect.y,imageRect.x + imageRect.width,
	        imageRect.y + imageRect.height,sourceRect.x,sourceRect.y,
	        sourceRect.x + sourceRect.width,sourceRect.y + sourceRect.height,null);
	    else if (sameSize)
	      g.drawImage(image,imageRect.x,imageRect.y,null);
	    else
	      g.drawImage(image,imageRect.x,imageRect.y,imageRect.width,imageRect.height,null);
	      }
     timer++;
     if (timer>= 2){
         timer = 0;         
            if (Switches.ScanLines){
                if (imageRect.height >= 548)
                scanlines=true;
                else
                scanlines = false;}
            else
            scanlines=false;
     }
         if (scanlines){
              for (int i=0; i< imageRect.height; i=i+2)
	      g.drawLine(imageRect.x, imageRect.y+i, imageRect.width, imageRect.y+i);
          }
	      // draw floppy-LED
	      
	    
	      if (ledOn == 1) {
	           /* g.setColor(LED_BORDER);
	            g.fillRect(imageRect.width - 22 ,8 , 17, 9);
	            //g.drawRect(imageRect.x,imageRect.y , imageRect.width - 1, imageRect.height - 1);
	            g.setColor(LED);
	            g.fillRect(imageRect.width - 20 ,10 ,13, 5);*/
                    if (imageRect.height >= 548)
                     g.drawImage(floppy2,imageRect.width - 60,8, this);
                    else
                     g.drawImage(floppy,imageRect.width - 20,8, this);
	            }
	  
	
              if (txtpos > 0){
                  g.drawImage(about, imageRect.width / 2 - 110 , ytext - 20, this);
	        txtpos = txtpos -1;
	        if (txtpos > 255){
	            ytext = ytext + 1;}
	        if (txtpos < 50){
	            ytext = ytext - 1;}
	       }
              	      
	    {if (showfps >= 1){
	        String fps = ("FPS: " + mCurrFPS);
	        g.setColor(ALERT);
	        g.drawString(fps, imageRect.width - 91, imageRect.height - 6);
	        }
	      }
	          
	       
	  if (Switches.osddisplay){ 
	   
	  
	      // show credits
	      
	     
	      // show selected monitor

	      {if (showmon >= 0){
	        g.setFont(new Font("",1,11));
	        g.setColor(BLACKA);
	        g.drawString(monmessage, imageRect.width - 90, imageRect.height - 20);
	        g.setColor(YELLOWA);
	        g.drawString(monmessage, imageRect.width - 91, imageRect.height - 22);
	        showmon = showmon -2;}
	      }  
	      
	      {if (showmodel >= 0){
	        g.setFont(new Font("",1,11));
	        g.setColor(BLACKA);
	        g.drawString(model, imageRect.width - 120, imageRect.height - 34);
	        g.setColor(REDA);
	        g.drawString(model, imageRect.width - 121, imageRect.height - 36);
	        showmodel = showmodel -2;}
	      }      
	      
	      
	      // show autosave-state
	      
	      {if (showauto >= 0){
	        g.setFont(new Font("",1,11));
	        g.setColor(BLACKA);
	        g.drawString(automessage, 6, imageRect.height - 54);
	        g.setColor(GREEN);
	        g.drawString(automessage, 6, imageRect.height - 52);
	        showauto = showauto -2;}
	      }
	      
	      // show drive content
	      
	      {if (showdisk >= 0){
	        g.setFont(new Font("",3,11));
	        g.setColor(BLACKA);
	        g.drawString("DF0: " + Switches.loaddrivea , 6 , imageRect.height - 37);
	        g.drawString("DF1: " + Switches.loaddriveb , 6 , imageRect.height - 26);
	        g.drawString("DF2: " + Switches.loaddrivec , 6 , imageRect.height - 15);
	        g.drawString("DF3: " + Switches.loaddrived , 6 , imageRect.height - 4);
	        g.setColor(WHITEA);
	        g.drawString("DF0: " + Switches.loaddrivea , 5 , imageRect.height - 39);
	        g.drawString("DF1: " + Switches.loaddriveb , 5 , imageRect.height - 28);
	        g.drawString("DF2: " + Switches.loaddrivec , 5 , imageRect.height - 17);
	        g.drawString("DF3: " + Switches.loaddrived , 5 , imageRect.height - 6);
	        showdisk = showdisk -2;}
	      }
	      
	  }
	      
	            {if (showpause >= 0){
	           {if (Switches.osddisplay){
	            g.setFont(new Font("",3,14));
	            g.setColor(BLACKA);        
	            g.drawString("Pause", imageRect.width - 45 , 40);
	            g.setColor(REDA);
	            g.drawString("Pause", imageRect.width - 46 , 39);
	            }
	           } showpause--;
	        }
	      }
          
	  {if (bootgames >= 1){
	            g.setColor(ALERT);
	            g.drawString("AUTOBOOT IN PROGRESS " , imageRect.width / 2 - 70 , imageRect.height / 2);
	            g.drawString("AUTOBOOT IN PROGRESS " , imageRect.width / 2 - 71 , imageRect.height / 2);
	       bootgames--;
                   }}	 
              {if (autotype >= 1){
	            g.setColor(WHITEA);
                    g.setFont(new Font("",3,12));
	            g.drawString("Autotype in action... Please don't touch the keys" , imageRect.width / 2 - 130 ,imageRect.height - 18);
	       
                   }}
	  {if (showboot >= 1){
	            g.setColor(ALERT);
	        g.setFont(new Font("",1,13));
	            g.drawString("AUTOBOOT IN PROGRESS " + showboot, imageRect.width / 2 - 80 , imageRect.height / 2);
	            g.drawString("AUTOBOOT IN PROGRESS " + showboot, imageRect.width / 2 - 81 , imageRect.height / 2);
	       showboot--;
	   }}
	         
	            // autoload DSK and SNA
	  {if (loadgames >= 1){
	            g.setColor(ALERT);
	            g.drawString("AUTOSTART IN PROGRESS " , imageRect.width / 2 - 70 , imageRect.height / 2);
	            g.drawString("AUTOSTART IN PROGRESS " , imageRect.width / 2 - 71 , imageRect.height / 2);
	       loadgames--;
	       if (loadgames == 20){
	           JEMU.autoloader = 1;
	       }
	       if (loadgames == 4){
	           JEMU.autoloader = 2;
	       }
	   }}            
	   
	  {if (loadtimer > 0){
	            g.setColor(ALERT);
	            g.drawString(" AUTOLOAD IN PROGRESS " , imageRect.width / 2 - 70 , imageRect.height / 2);
	            g.drawString(" AUTOLOAD IN PROGRESS " , imageRect.width / 2 - 71 , imageRect.height / 2);
	  
	   }}
	   
	  }

  long mLastFPSTime;
  int mNextFPS;
  int mCurrFPS;
  void doTouchFPS()
  {
	  long time = System.currentTimeMillis();
	  mNextFPS++;
	  if (time-mLastFPSTime >= 1000)
	  {
		  mCurrFPS = mNextFPS;
		  mNextFPS = 0;
		  mLastFPSTime = time;
	  }
  }
  
  protected Rectangle paintRect = new Rectangle();

  
    public void setBackground(Color bg) {
    }
    
  protected Rectangle clipRect = new Rectangle();
  
  
  public void paintComponent(Graphics g) {
    if (image != null)
      paintImage(g);
    painted = true;
  }

  
  public Dimension getPreferredSize() {
    Insets insets = getInsets();
    return new Dimension(imageRect.width + insets.left + insets.right,
                imageRect.height + insets.top + insets.bottom);
  }

  public int getImageWidth() {
    return imageWidth;
  }

  public int getImageHeight() {
    return imageHeight;
  }

  public boolean isPainted() {
    return painted;
  }

  public void setPainted(boolean value) {
    painted = value;
  }

  public void waitPainted() {
    while (!painted && isShowing())
      Thread.yield();
  }

  protected void processFocusEvent(FocusEvent e) {
    super.processFocusEvent(e);
    if (e.getID() == FocusEvent.FOCUS_GAINED) {
      System.out.println("Display Focused");
    }
    else
      System.out.println("Display Lost Focus");
  }

}